org.eclipse.rdf4j.federated.evaluation.iterator

## Class LazyMutableClosableIteration

- java.lang.Object
- - org.eclipse.rdf4j.federated.evaluation.iterator.LazyMutableClosableIteration

- All Implemented Interfaces:
    AutoCloseable, CloseableIteration<BindingSet,QueryEvaluationException>, Iteration<BindingSet,QueryEvaluationException>

      public class LazyMutableClosableIteration
      extends Object
      implements CloseableIteration<BindingSet,QueryEvaluationException>

  A specialized `CloseableIteration` that allows repetitive iterations after resetting the cursor using `resetCursor()`.

  Note that the inner iteration is lazily consumed.

  Author:
    Andreas Schwarte

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected List<BindingSet>` | `consumed`
    `protected int` | `cursorIdx` the cursor index, is used after the inner iteration is fully consumed
    `protected CloseableIteration<BindingSet,QueryEvaluationException>` | `inner`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `LazyMutableClosableIteration(CloseableIteration<BindingSet,QueryEvaluationException> inner)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes this iteration, freeing any resources that it is holding.
    `boolean` | `hasNext()` Returns `true` if the iteration has more elements.
    `BindingSet` | `next()` Returns the next element in the iteration.
    `void` | `remove()` Removes from the underlying collection the last element returned by the iteration (optional operation).
    `void` | `resetCursor()` Reset the cursor to read from the already consumed bindings.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.rdf4j.common.iteration.Iteration

      `stream`

- - ### Field Detail

    - #### inner

          protected final CloseableIteration<BindingSet,QueryEvaluationException> inner

    - #### consumed

          protected List<BindingSet> consumed

    - #### cursorIdx

          protected volatile int cursorIdx

      the cursor index, is used after the inner iteration is fully consumed

  - ### Constructor Detail

    - #### LazyMutableClosableIteration

          public LazyMutableClosableIteration(CloseableIteration<BindingSet,QueryEvaluationException> inner)

  - ### Method Detail

    - #### hasNext

          public boolean hasNext()
                          throws QueryEvaluationException

      Description copied from interface: `Iteration`
      Returns `true` if the iteration has more elements. (In other words, returns `true` if `Iteration.next()` would return an element rather than throwing a `NoSuchElementException`.)
      Specified by:
        `hasNext` in interface `Iteration<BindingSet,QueryEvaluationException>`
      Returns:
        `true` if the iteration has more elements.
      Throws:
        `QueryEvaluationException`

    - #### next

          public BindingSet next()
                          throws QueryEvaluationException

      Description copied from interface: `Iteration`
      Returns the next element in the iteration.
      Specified by:
        `next` in interface `Iteration<BindingSet,QueryEvaluationException>`
      Returns:
        the next element in the iteration.
      Throws:
        `QueryEvaluationException`

    - #### remove

          public void remove()
                      throws QueryEvaluationException

      Description copied from interface: `Iteration`
      Removes from the underlying collection the last element returned by the iteration (optional operation). This method can be called only once per call to next.
      Specified by:
        `remove` in interface `Iteration<BindingSet,QueryEvaluationException>`
      Throws:
        `QueryEvaluationException`

    - #### close

          public void close()
                     throws QueryEvaluationException

      Description copied from interface: `CloseableIteration`
      Closes this iteration, freeing any resources that it is holding. If the iteration has already been closed then invoking this method has no effect.
      Specified by:
        `close` in interface `AutoCloseable`
      Specified by:
        `close` in interface `CloseableIteration<BindingSet,QueryEvaluationException>`
      Throws:
        `QueryEvaluationException`

    - #### resetCursor

          public void resetCursor()

      Reset the cursor to read from the already consumed bindings.

Copyright © 2015-2022 Eclipse Foundation. All Rights Reserved.